#ifndef __PF2ASM_AST_ADDRESSING_TEXT_H__
#define __PF2ASM_AST_ADDRESSING_TEXT_H__

#include <cdk/ast/basic_node.h>

namespace pf2asm {

  class TEXT: public cdk::basic_node {
    std::string _name;

  public:
    TEXT(int lineno) :
        cdk::basic_node(lineno), _name("") {
    }
    TEXT(int lineno, const std::string &name) :
        cdk::basic_node(lineno), _name(name) {
    }
    TEXT(int lineno, int number) :
        cdk::basic_node(lineno), _name("T" + std::to_string(number)) {
    }
    const std::string &name() const {
      return _name;
    }
    void accept(basic_ast_visitor *sp, int level) {
      sp->do_TEXT(this, level);
    }
  };

} // pf2asm

#endif
